#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include "exports.h"
#include "cwstart.h"

LIBMAIN

/* Exported functions */
long DLL CountOccurances(LPSTR srchStr);
long DLL CountPhrase(LPSTR srchStr);

void DLL 
_init()
{
	static BOOL firstTime = TRUE;

	if (firstTime) {
		LibExport("long CountOccurances LPSTR");
		LibExport("long CountPhrase LPSTR");

		firstTime = FALSE;
	}
}

long DLL CountOccurances(LPSTR srchStr)
{
	DWORD oldOffset = BufQOffset();
	long firstLine = WinQFirstLine();
	long leftCol = WinQLeftColumn();
	long count = 0;

	MovToOffset(0);
	while (SrchFind(srchStr, SrchQFlags(), NULL)) {
		count++;
		MovNextChar(1);
 	}
	MarkRemoveSel();
	MovToOffset(oldOffset);
	WinSetTopLeft(firstLine, leftCol);
	return(count);
}

long DLL CountPhrase(LPSTR srchStr)
{
	char tmpStr[200];
	long count = CountOccurances(srchStr);
	_ltoa(count, tmpStr, 10);
	strcat(tmpStr, " occurances found.");
	MsgMessage(tmpStr);
	return(count);
}